/*############################################################################
 Copyright:      Markus KOtschenreuther
 Author:         Markus KOtschenreuther
 Remarks:
 known Problems: none
 Version:        10.2011
 Description:
############################################################################*/

#ifndef _FROELING_COM_H_
 #define _FROELING_COM_H_

//******************************************
// defines
//******************************************
#define FROELING_USER_ID 		-7
#define NB_OF_PROCESS_VALUES	27  // number of process values contained in M1 frames
#define ALIVE_CHECK_TIMESPAN   	30 // in seconds
#define RECEIVE_BUF_SIZE 		128

#define USR UCSRA
#define UCR UCSRB
#define UBRR UBRRL
#define EICR EICRB

#define FR_T_DAY		0
#define FR_T_MONTH 		1
#define FR_T_YEAR 		2
#define FR_T_HOUR 		3
#define FR_T_MINUTE 	4
#define FR_T_SECOND 	5
#define FR_T_DAYOFWEEK 	6

#define FR_V_WORKMODE 			0
#define FR_V_STATE	 			1
#define FR_V_ZUSTAND 			2
#define FR_V_ROST				3
#define FR_V_KESSELTEMP 		4
#define FR_V_ABGASTEMP 			5
#define FR_V_ABGASTEMPSW 		6
#define FR_V_KESSELSTELLGR 		7
#define FR_V_SAUGZUG 			8
#define FR_V_ZUGLUFTGEBLAESE 	9
#define FR_V_EINSCHUB 			10
#define FR_V_RESTO2 			11
#define FR_V_O2REGLER 			12
#define FR_V_FUELLSTAND 		13
#define FR_V_FEUERRAUMTEMP 		14
#define FR_V_PUFFERTEMPUP 		15
#define FR_V_PUFFERTEMPDOWN 	16
#define FR_V_BOILERTEMP 		17
#define FR_V_AUSSENTEMP 		18
#define FR_V_VORLAUFTEMPSW 		19
#define FR_V_VORLAUFTEMP 		20
#define FR_V_KTY6 				21
#define FR_V_KTY7 				22
#define FR_V_BRENNERSTARTS 		23
#define FR_V_LAUFZEIT 			24
#define FR_V_BOARDTEMP 			25
#define FR_V_KESSELTEMPSW 		26

#define FR_S_BRENNER_AUS		1
#define FR_S_VORBEREITUNG		x
#define FR_S_HEIZEN				3
#define FR_S_ANHEIZEN			x
#define FR_S_VORWAERMEN			x
#define FR_S_ZUENDEN			x
#define FR_S_FEUERHALTUNG		x
#define FR_S_ABSTWARTEN1		11
#define FR_S_ABSTEINSCHUB1		x
#define FR_S_ABSTWARTEN2		13
#define FR_S_ABSTEINSCHUB2		x
#define FR_S_STOERUG			x
#define FR_S_FEHLERB20MIN		x

//******************************************
// typedefs
//******************************************
typedef enum {
	STM_FR_INIT,
	STM_FR_RECEIVE_MSG,
	STM_FR_HANDLE_M1,
	STM_FR_HANDLE_M2
}T_FROE_COM_STM;

typedef enum {
	STM_SUB_FR_RECEIVE_HEADER,
	STM_SUB_FR_RECEIVE_REPLY_BODY,
	STM_SUB_FR_RECEIVE_MESSAGE_BODY,
}T_FROE_COM_SUBSTM;

typedef struct
{
	T_FROE_COM_STM   tCurrentMainState;
	T_FROE_COM_SUBSTM tCurrentSubState;
	char cReceiveBuffer[RECEIVE_BUF_SIZE];
	int iInBuffPointer;
	char cRbSendFlag;
	unsigned int  iMsgLength;
	short glsUserID;
	int iLastFroelingTimestamp;
	unsigned long ulLastSystemTimestamp;

	// bits
	unsigned short	bSetValue		: 1;

}T_FROE_COM_DATA;

// variables
// ---------------------------------------
extern T_FROE_COM_DATA tFroeComStmData;

// function prototypes
// ---------------------------------------
extern void FroeCom_Init(void);
extern int FroeComSTM(void);

// variables
// ---------------------------------------
extern unsigned int froeling_proc_value_array[];
extern unsigned int froeling_get_time_array[];

#endif //_FROELING_COM_H_

