/*----------------------------------------------------------------------------
 Author:         Markus Kotschenreuther
 Remarks:
 known Problems: none
 Version:        15.10.2012
 Description:    Froeling P2 <-> I2C Adapter

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der
 GNU General Public License, wie von der Free Software Foundation verffentlicht,
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder
 (nach Ihrer Option) jeder spteren Version.

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung,
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE,
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 Programm erhalten haben.
 Falls nicht, schreiben Sie an die Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "config.h"
#include "std_defs.h"
#include "uart.h"
#include "twislave.h"
#include "froeling_com.h"
#include "timer.h"
#include "../common/twi_interface.h"

#if(ENABLE_DEBUG_MESSAGES >= 1)
long a;
#endif

long a;

int main(void)
{
	//Globale Interrupts ausschalten
	cli();

	//Timer starten
	timer_init();

    // init UART
    uart_init();
	uart_flush();
	uart_fifo_flush();

    // init TWI
	init_twi_slave(TWI_SL_ADR_COM_FROELING);				//TWI als Slave mit Adresse slaveadr starten

	// init froeling statemachine
	FroeCom_Init();

	//Globale Interrupts einschalten
	sei();

#if(ENABLE_DEBUG_MESSAGES >= 1)
	uart_puts("Froeling-Slave\n\r");
#endif

	// MAINLOOP
	//************************************************
	while(1)
	{
		// froeling communication statemachine
		FroeComSTM();

    }//while (1)

return(0);
}

